#include "iostream"
#include "stdlib.h"
using namespace std;

int main(){
	int T;
	cin >> T;
	
	for(int i=0;i<T;i++){
		int n, m;
		
		cin >> n >> m;
		
		int a, b, razlika;
		
		cin >> a >> b;
		
		razlika = abs(a-b);
		
		a = b;
		
		for(int j=0;j<n-2;j++){
			cin >> b;
			int temp = abs(a-b);
			
			while(temp!=razlika)
				if(temp>razlika)
					temp -= razlika;
				else
					razlika -= temp;
			
			a = b;
		}

		bool da = true;

		for(int j=0;j<m;j++){
			int p;
			cin >> p;
			
			if((p-a)%razlika==0){
				da = false;
				for(int l=0;l<m-l-1;l++)
					cin >> a;
				break;
			}
		}
		
		cout << da << endl;
	}
	
	return 0;
}